//
//  accelerometer.c
//  ideball_v02
//
//  Created by lixouda on 6/30/11.
//  Copyright 2011 RWTH AACHEN. All rights reserved.
//

#include "accelerometer.h"
/*
 *  mma7260q.c
 *  ball
 *
 *  Created by lixouda on 9/28/09.
 *  Copyright 2009 RWTH AACHEN. All rights reserved.
 *
 */

//static int uart_putchar(char c, FILE *stream);
//uint8_t uart_getchar(void);
volatile int x_read1;
volatile int x_read2;

volatile int y_read1;
volatile int y_read2;

volatile int z_read1;
volatile int z_read2;

volatile int z_shake;
volatile int y_shake;
volatile int x_shake;


volatile int shaked;
volatile int axisIndex;
volatile int overflowCounter;
volatile int shakeCount; //take back to mma7260q 
						 //volatile char shaked; //turn into extern


//static FILE mystdout = FDEV_SETUP_STREAM(uart_putchar, NULL, _FDEV_SETUP_WRITE);

ISR(ADC_vect)
{
	switch(axisIndex)
	{
			
		case 0:
		case 1:
			axisIndex++;
			if (z_shake > 2)
			{
				break;
			}
			z_read1 = ADC; //replace this with function using pointers
			checkShake(&z_read1, &z_shake);
			break;

		case 2:
			//switch channel to read y value;
			axisIndex++;
			ADMUX &= 0xF8; //switch to analog1
			ADMUX |= ( 1 << MUX0);
			if (z_shake > 2)
			{
				break;
			}
			z_read1 = ADC; //replace this with function using pointers
			checkShake(&z_read1, &z_shake);
			
			break;
			
			
			
		case 3:
		case 4:
			axisIndex++;
			if (y_shake > 2)
			{
				break;
			}
			y_read1 = ADC; //replace this with function using pointers
			checkShake(&y_read1, &y_shake);

			break;
			
		case 5:
			//switch channel to read x value;
			axisIndex++;
			ADMUX &= 0xF8; //switch to analog2
			ADMUX |= ( 1 << MUX1);
			
			if (y_shake > 2)
			{
				break;
			}
			
			y_read1 = ADC; //replace this with function using pointers
			checkShake(&y_read1, &y_shake);
			
			break;
			

		case 6:
		case 7:
			axisIndex++;

			if (x_shake > 2)
			{
				break;
			}
			
			x_read1 = ADC; //replace this with function using pointers
			checkShake(&x_read1, &x_shake);
			
			break;
			
		case 8:
			
			//switch channel to read z value;
			axisIndex=0;
			ADMUX &= 0xF8; //switch to analog0
			
			if (x_shake > 2)
			{
				break;
			}
			
			x_read1 = ADC; //replace this with function using pointers
			checkShake(&x_read1, &x_shake);
			
			break;
			
	}

	
}

void checkShake(volatile int* axisAcceleration, volatile int* axisShakeCount)
{
	if (*axisAcceleration > MAXG)
	{
		if ((*axisShakeCount) % 2 == 1)
		{
			*axisShakeCount = 0; // no alteration between MAXG and MING sorry....reset z_shake
			
			
		}
		else {			
			(*axisShakeCount)++;
			
		}
		return;	
		
	}
	

	if ( (*axisShakeCount) %2 == 1 )
	{
		if   (*axisAcceleration < MING)
		{
			(*axisShakeCount)++;
			
		}
		else {
			(*axisShakeCount) = 0;

		}

	}

}
/* timer to start ACD conversion for accelerometer values */
ISR(TIMER1_OVF_vect) { 
	
	// TODO: Reload timer with 29535 = (2^16 -1) - 36000
	TCNT1 =  4500;
	
}



//init IO ports including UART	
void acceler_ioinit()
{
	
	ADCDDR &= ~( 1 << XPIN); 
	ADCDDR &= ~( 1 << YPIN);
	ADCDDR &= ~( 1 << ZPIN);
	
	//  voltage ref: we are using AREF with internal Vref turned off
	// REFS1..0 - reference selection bits
	ADMUX = 0;
	
	
	//enable ADC, and set the prescaler to 128 (for 18MHz, we get 125KHz)	
	//ADATE -> enable autotriggering...in this case timer1 overflow
	//ADIE -> enable "conversion complete interrupt"
	// ADPS2...0 - ADC prescaler select bits
	ADCSRA |= (1 << ADEN) | ( 1 << ADATE) | ( 1 << ADIE) | ( 1 << ADPS2) | ( 1 << ADPS1) | (1 << ADPS0);
	
	
	//ADTS2..0  = 1-1- 0 trigger on timer/counter1 overflow
	ADCSRB |= (1 << ADTS2)| (1 << ADTS1);

	
	//setup timer 1 overflow 
	// TODO: enable overflow interrupt
	TIMSK1 |= ( 1 << TOIE1);	
	// TODO: Load timer with 65410 = (2^16 -1) - 125 , with prescaler at 8 and a desired overflow @54ms ~ 18.432Hz
	TCNT1 =  65140;
	//for 1/20s trigger: (2^16 - 14400) = 51135
	//TCNT1 = 51135;
    // TODO: Set up timer1 at FCPU/8 for FCPU 18.432MHz 
    TCCR1B |= (1 << CS11); 
	
	
	/*
	//setup timer 1 overflow 
	// TODO: enable overflow interrupt
	TIMSK1 |= ( 1 << TOIE1);	
	// TODO: Load timer with 29535 = (2^16 -1) - 36000 
	TCNT1 =  29535;
	//for 1/20s trigger: (2^16 - 14400) = 51135
	//TCNT1 = 51135;
    // TODO: Set up timer1 at FCPU/64 for FCPU 18.432MHz 
    TCCR1B |= (1 << CS11) | (1 << CS10); 
	*/
	
	
	//initialize variables
   	x_read1 = x_read2 = 6; 
 	y_read1 = y_read2 = 0; 
 	z_read1 = z_read2 = 0; 
	
	
	x_shake = 0;
	z_shake = 0;
	y_shake = 0;
	
	shaked = 0;
	axisIndex = 0;
	shakeCount = 0;
	overflowCounter = 0;
	
}

int shakeCheck(void)
{
	
	if ((x_shake / 2) + (y_shake / 2) + (z_shake / 2) > 1)
	{
		
		x_shake = 0;
		y_shake = 0;
		z_shake = 0;
		return 1;
	}
	return 0;
	
}

