//
//  accelerometer.h
//  ideball_v02
//
//  Created by lixouda on 6/30/11.
//  Copyright 2011 RWTH AACHEN. All rights reserved.
//

#ifndef ADXL330_H
#define ADXL330_H

#include <avr/io.h>
#include <stdio.h>
#include <math.h>
#include <avr/interrupt.h>
//#include "uart0.h"

/** accelerometer #defines **/
#define ADCDDR PORTA
#define ZPIN PINA0
#define YPIN PINA1
#define XPIN PINA2


#define MAXG 513	// if  axis acceleration >1.3g then it's shaken on that axis. on adxl330k 1.3g = 586 decimal
#define MING 341 // if  axis acceleration < -1.3g then it's shaken on that axis. on adxl330k -1.3g = 341 decimal

extern volatile int x_read1;
extern volatile int x_read2;

extern volatile int y_read1;
extern volatile int y_read2;

extern volatile int z_read1;
extern volatile int z_read2;


extern volatile int overflowCounter;

extern volatile int shakeCount; //take back to mma7260q 

void acceler_ioinit(void);
void checkShake(volatile int* axisAcceleration, volatile int* axisShakeCount);
int shakeCheck(void);
#endif


