/*
 *  uart.c
 *  ideball_v02
 *
 *  Created by lixouda on 6/29/11.
 *  Copyright 2011 RWTH AACHEN. All rights reserved.
 *
 */

/*
 *  uart.c
 *  ball
 *
 *  Created by lixouda on 9/28/09.
 *  Copyright 2009 RWTH AACHEN. All rights reserved.
 *
 */

#include "uart.h"
#include <avr/io.h>

/*
ISR(USART1_RX_vect) {
	Buffer_StoreElement(&receiveBuff, UDR1);
}*/



volatile uint8_t received;

void USART0Init(unsigned int ubrr) {
	
	DDRD |= 0b00000010; // TX0 = 1; RX0 = 0;
	
	//set baud value in UBBR register. UBBR is 16 bits big
	UBRR0L = (unsigned char) ubrr;
	UBRR0H =  (unsigned char)(ubrr >> 8);
	//enable receiver and transmiter
	UCSR0B |= (1 << RXEN0) | (1 << TXEN0);
	
	//set character size to 8 bits: UCSZ2 = 0, USCZ1 = 1, UCSZ0 = 1
	UCSR0C |= (1 << UCSZ01) | (1 << UCSZ00);
	UCSR0B &= ~(1 << UCSZ02);
	
	
	UCSR0B |= (1 << RXCIE0 ); //enable receive interrupt
	//UCSR0B &= ~(1 << TXCIE0); //disable transmit interrupt
							  //UCSR0B |= (1 << TXCIE0); //enable transmit interrupt
	received = 0;
	//  stdout = &mystdout; //Required for printf init
}

void USART1Init(unsigned int ubrr) {
	
	DDRD |= 0b00001000; // TX1 = 1; RX1 = 0;
	
	//set baud value in UBBR register. UBBR is 16 bits big
	UBRR1L = (unsigned char) ubrr;
	UBRR1H =  (unsigned char)(ubrr >> 8);
	//enable receiver and transmiter
	UCSR1B |= (1 << RXEN1) | (1 << TXEN1);
	
	//set character size to 8 bits: UCSZ2 = 0, USCZ1 = 1, UCSZ0 = 1
	UCSR1C |= (1 << UCSZ11) | (1 << UCSZ10);
	UCSR1B &= ~(1 << UCSZ12);
	
	UCSR1A &=  ~ (1 << U2X1);
	
	UCSR1B |= (1 << RXCIE1 ); //enable receive interrupt
							  //UCSR1B &= ~(1 << TXCIE1); //disable transmit interrupt
							  //UCSR0B |= (1 << TXCIE0); //enable transmit interrupt
	
	//  stdout = &mystdout; //Required for printf init
	
	
}


int uart_putchar(char c, FILE *stream) //used for printf...only for usart1
{
	if (c == '\n') uart_putchar('\r', stream);
	loop_until_bit_is_set(UCSR1A, UDRE1); //loop until we can put new data in the transmit buffer
	UDR1 = c; //put data in the buffer
	return 0;
}


char uart0_read(void) {
	return UDR0; 
}

char uart1_read(void) {
	return UDR1; 
}

/*char uart1_read(void) {
 return UDR1;
 }*/
char uart0_waitandread(void) {
	while(!uart0_char_is_waiting()) {};
	return UDR0; 
}

/*char uart1_waitandread(void) {
 while(!uart1_char_is_waiting()) {};
 return UDR1; 
 }*/

void uart0_write(char v) {
	while (!(UCSR0A & (1 << UDRE0))) {} //loop until we can write to the transmit register
	UDR0 = v;
}

void uart1_write(char v) {
	while (!(UCSR1A & (1 << UDRE1))) {} //loop until we can write to the transmit register
	UDR1 = v;
}

uint8_t uart0_char_is_waiting(void) {
	return (UCSR0A & (1 << RXC0)); //return 1 if there's unreaad data in the receive buffer
								   //return 0 if the buffer is empty or the receiver is disabled	
}

uint8_t uart1_char_is_waiting(void) {
	return (UCSR1A & (1 << RXC1)); //return 1 if there's unreaad data in the receive buffer
								   //return 0 if the buffer is empty or the receiver is disabled	
}



