/*
 *  uart.h
 *  ideball_v02
 *
 *  Created by lixouda on 6/29/11.
 *  Copyright 2011 RWTH AACHEN. All rights reserved.
 *
 */

/*
 *  uart.h
 *  ball
 *
 *  Created by lixouda on 9/28/09.
 *  Copyright 2009 RWTH AACHEN. All rights reserved.
 *
 */

#ifndef UART_H
#define UART_H 

#include <avr/io.h>
#include <stdio.h>
#include "ringbuff.h"

#define USART0 0 //used for rfid info
#define USART1 1 //used for talking to bt module

/* Setting the baud value: 
 * Assume an F_CPU of 18.4320MHz
 * Baud Rate = ******9600bps******** for ID12
 * BaudValue ( UBRR register) = (((F_CPU / (USART_BAUDRATE * 16UL))) - 1)
 * from the datasheet: BaudValue = 119 for asynchronous, normal mode by 9600bps
 * the error is 0.0%...I can live with that :)
 */ 
#define UBRR0VAL 119 //id12 works @9600bps

#define UBRR1VAL 9 //wt32 is set to 115.2kbps
//extern RingBuff_t receiveBuff; //volatile 

//static FILE mystdout = FDEV_SETUP_STREAM(uart_putchar, NULL, _FDEV_SETUP_WRITE);

int uart_putchar(char c, FILE *stream);
void USART0Init(unsigned int ubbr);
void USART1Init(unsigned int ubbr);
uint8_t uart0_char_is_waiting(void);
uint8_t uart1_char_is_waiting(void);

char uart0_read(void);
char uart1_read(void);
void uart0_write(char v);
void uart1_write(char v);
char uart0_waitandread(void);
//char uart1_waitandread(void);

#endif
